<template>
    <div class="cont">
        <v-text-field type="number" hide-details dense label="Value" v-model.number="enumVal.value" @blur='changedValue' @keydown.enter='changedValue'></v-text-field>
        <v-text-field label="Text" v-model="enumVal.label" @blur='changedText' @keydown.enter='changedText'></v-text-field>
        <BooleanEditor label="Use Custom Colors" v-model="enumVal.customColors" @input="changedCustomColor"></BooleanEditor>
        <ColorEditor v-show="enumVal.customColors" label="Text Color" v-model="enumVal.textColor" @input="changedFg"></ColorEditor>
        <ColorEditor v-show="enumVal.customColors" label="Background" v-model="enumVal.backgroundColor" @input="changedBg"></ColorEditor>
        <v-btn class="btn" x-small @click='remove()'>DELETE</v-btn>
    </div>    
</template>

<script lang="ts">
import Vue from 'vue'
import { Enum } from '../ItemData'
import ColorEditor  from '@/components/ColorEditor.vue';
import BooleanEditor from '@/components/BooleanEditor.vue';

export default Vue.extend({
    props: {
      enumVal: {
        type: Enum,
        required: true
      }
    },

    computed: {        
    },

    methods: {
        changedText(): void {
            //console.log("changedText");       
            this.$emit("changed"); 
        },
        changedValue(): void {
            //console.log("changedValue"); 
            this.$emit("changed"); 
        },
        changedCustomColor(): void { 
            //console.log("changedCustomColor"); 
            this.$emit("changed"); 
        },
        changedFg(): void { 
            //console.log("changedFg");     
            this.$emit("changed"); 
        },
        changedBg(): void {
            //console.log("changedBg");    
            this.$emit("changed"); 
        },
        remove(): void {
            this.$emit("remove");
        }
    },

    components: { ColorEditor, BooleanEditor }
})
</script>

<style scoped>

.cont {
    border: 1px solid #555555;
    padding-top: 14px;
    margin-top: 6px;
    border-radius: 10px;
    background-color: #292929;
}

.btn {
    max-width: 20%;
}


</style>